/*

Here is an example of creating a PickBrowse
that functions equivalent to DCPICKLIST except
it uses Browse objects.

*/

#include "dcdialog.ch"
#INCLUDE "dcpick.CH"
#INCLUDE "appevent.CH"
#INCLUDE "dccursor.CH"

#command @ <nRow>, <nCol> DCPICKBROW <aPick> LIST <aList>                   ;
              [DATALINK <bLink>]                                            ;
              [PARENT <oParent> ]                                           ;
              [PRESENTATION <aPres>]                                        ;
              [FONT <(font)> ]                                              ;
              [TOOLTIP <cToolTip> ]                                         ;
              [MESSAGE <cMsg> [INTO <oMsg>]]                                ;
              [CARGO <xCargo>]                                              ;
              [SIZE <nWidth> [, <nHeight>] ]                                ;
              [CAPTION <cLeftCap> [,<cRightCap> ] ]                         ;
              [EVAL <bEval> ]                                               ;
              [PIXEL <lPixel>]                                              ;
              [WHEN <bWhen>]                                                ;
              [HIDE <bHide>]                                                ;
              [OBJECT <oObject>]                                            ;
              [ID <cId> ]                                                   ;
              [TITLE <cTitle> ]                                             ;
              [RELATIVE <oRel> ]                                            ;
              [GROUP <cGroup>]                                              ;
              [BUTTONS <aButtons>]                                          ;
=> ;
[<oObject> :=]                                                              ;
   PickBrowse( GetList,                         ;
    { <aPick>,                                  ;    // 1
      <aList>,                                  ;    // 2
      <nRow>,                                   ;    // 3
      <nCol>,                                   ;    // 4
      <nWidth>,                                 ;    // 5
      <nHeight>,                                ;    // 6
      <font>,                                   ;    // 7
      <oParent>,                                ;    // 8
      <bWhen>,                                  ;    // 9
      <cToolTip>,                               ;    // 10
      <xCargo>,                                 ;    // 11
      <bLink>,                                  ;    // 12
      <cMsg>,                                   ;    // 13
      <oMsg>,                                   ;    // 14
      <lPixel>,                                 ;    // 15
      <bEval>,                                  ;    // 16
      <oRel>,                                   ;    // 17
      <cTitle>,                                 ;    // 18
      <cId>,                                    ;    // 19
      <bHide>,                                  ;    // 20
      <cGroup>,                                 ;    // 21
      <cLeftCap>,                               ;    // 22
      <cRightCap>,                              ;    // 23
      <aPres>,                                  ;    // 24
      <aButtons> } )                                 // 25

* --------

FUNCTION Main()

LOCAL GetList[0], aList, aPick, oPickBrowse, lStatus

aList := { {'Roger',1}, ;
           {'Brian',2}, ;
           {'Larry',3}, ;
           {'Jeff',4}, ;
           {'Mark',5}, ;
           {'Charlene',6} }


aPick := { {'Samuel',7}, ;
           {'Hortense',8}, ;
           {'Felicia',9} }

@ 0,0 DCPICKBROW aPick LIST aList SIZE 30,10 PRESENTATION DC_BrowPres()

DCREAD GUI FIT TITLE 'Pick Browse Sample' ADDBUTTONS TO lStatus

wtf aList, aPick pause

RETURN nil

* ---------

PROC appsys
RETURN

* ---------

FUNCTION PickBrowse( GetList, aOptions, GetOptions )

LOCAL nRow, nCol, nWidth, nHeight, oObject, aSizePixels, ;
      i, aPres, nPointerAvailable := 1, nPointerSelected := 1, oToolBar, ;
      nCol1, nCol2, oParent, aAvailableList, aSelectedList, lPixel, cSeek, ;
     cFont, bWhen, cToolTip, bLink, cMsg, oMsg, bEval, oRel, cTitle, cId, bHide, ;
     cGroup, cLeftCap, cRightCap, aButtons, nButtonWidth

LOCAL oAvailable, ;
       oSelected, ;
      xCargo, ;
      cFocus := 'AVAILABLE'


aSelectedList  := aOptions[1]
aAvailableList := aOptions[2]
nRow           := aOptions[3]
nCol           := aOptions[4]
nWidth         := aOptions[5]
nHeight        := aOptions[6]
cFont          := aOptions[7]
oParent        := aOptions[8]
bWhen          := aOptions[9]
cToolTip       := aOptions[10]
xCargo         := aOptions[11]
bLink          := aOptions[12]
cMsg           := aOptions[13]
oMsg           := aOptions[14]
lPixel         := aOptions[15]
bEval          := aOptions[16]
oRel           := aOptions[17]
cTitle         := aOptions[18]
cId            := aOptions[19]
bHide          := aOptions[20]
cGroup         := aOptions[21]
cLeftCap       := aOptions[22]
cRightCap      := aOptions[23]
aPres          := aOptions[24]
aButtons       := aOptions[25]

FOR i := 1 TO Len(aSelectedList)
  AAdd(aSelectedList[i],.f.)
NEXT

FOR i := 1 TO Len(aAvailableList)
  AAdd(aAvailableList[i],.f.)
NEXT

DEFAULT lPixel := .f., ;
        cLeftCap := 'Available Items', ;
      cRightCap := 'Selected Items', ;
      cTitle := 'Picklist', ;
      xCargo := ' ', ;
      cToolTip := ' ', ;
      cGroup := ' ', ;
        cFont := ' ', ;
        cMsg := ' ', ;
        cId := ' ', ;
        cGroup := ' ', ;
      aPres := DC_BrowPres()

@ nRow, nCol DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
     SIZE nWidth, nHeight _PIXEL lPixel OBJECT oObject ;
     EVAL {|o|aSizePixels := o:currentSize()}

IF lPixel
  nRow := 3
  nCol1 := 3
  nCol2 := (nWidth/2)
  nWidth := (nWidth/2) - 6
  nHeight := nHeight - 6
ELSE
  nRow := 3/20
  nCol1 := 3/7
  nCol2 := (nWidth/2)
  nWidth := (nWidth/2) - (6/7)
  nHeight := nHeight - (6/20)
ENDIF

cSeek := space(15)
@ nRow -2, 0 DCSAY 'Search Available:' GET cSeek SAYRIGHTBOTTOM ;
      ;// PICT '@!' ;
      GETID 'SEEKGET' SAYSIZE 0 SAYFONT '10.Lucida Console' ;
      KEYBLOCK {|a,b,o|DC_BrowseAutoSeek(a,o,oAvailable,aAvailableList,,,{|c|Alltrim(c)},,,nPointerAvailable,.f.)}

@ DCGUI_ROW,DCGUI_COL + 10 DCSAY 'Use drag/drop or double click to move.' SAYSIZE 0 SAYFONT '10.Lucida Console'

@ nRow, nCol1 DCBROWSE oAvailable SIZE nWidth, nHeight ;
   DATA aAvailableList ;
   PRESENTATION aPres ;
   ;//NOHSCROLL ;
   PARENT oParent ;
   GOTFOCUS {||cFocus := 'AVAILABLE'} ;
   CARGO xCargo ;
   POINTER nPointerAvailable ;
   COLOR {|x|x:=DC_GetColArray(3,oAvailable),IIF(Empty(x),{nil,GRA_CLR_WHITE},{GRA_CLR_WHITE,GRA_CLR_BLUE})} ;
   ITEMSELECTED {||ListSelected(aAvailableList,aSelectedList,oAvailable,oSelected,nPointerAvailable,nPointerSelected)}

DCBROWSECOL ELEMENT 1 WIDTH nWidth PARENT oAvailable ;
   HEADER cLeftCap ;
   DRAG {|o|o} ;
     DIALOG {|mp1,mp2,oXbp|DragDialog(mp1,mp2,oXbp)} ;
    DROP {|a,b,c|Drop(a,b,c,oAvailable,oSelected)} CURSOR POINTER_DATADROP_MOVE

@ nRow, nCol2 DCBROWSE oSelected SIZE nWidth, nHeight ;
   DATA aSelectedList ;
   PRESENTATION aPres ;
   ;//NOHSCROLL ;
   PARENT oParent ;
   POINTER nPointerSelected ;
   GOTFOCUS {||cFocus := 'SELECTED'} ;
   CARGO xCargo ;
   COLOR {|x|x:=DC_GetColArray(3,oSelected),IIF(Empty(x),{nil,GRA_CLR_WHITE},{GRA_CLR_WHITE,GRA_CLR_BLUE})} ;
   ITEMSELECTED {||PickSelected(aAvailableList,aSelectedList,oAvailable,oSelected,nPointerAvailable,nPointerSelected)}

DCBROWSECOL ELEMENT 1 WIDTH nWidth PARENT oSelected ;
   HEADER cRightCap ;
   DRAG {|o|o} ;
     DIALOG {|mp1,mp2,oXbp|DragDialog(mp1,mp2,oXbp)} ;
    DROP {|a,b,c|Drop(a,b,c,oSelected,oAvailable)} CURSOR POINTER_DATADROP_MOVE

nRow += .5

@ nRow + nHeight, nCol1 DCPUSHBUTTON CAPTION 'Up' SIZE 5,1 ;
           ACTION {|a|a := aAvailableList[nPointerAvailable], ;
                      ARemove(aAvailableList,nPointerAvailable), ;
                      ASize(aAvailableList,Len(aAvailableList)+1), ;
                      AIns(aAvailableList,nPointerAvailable-1,a), ;
                      oAvailable:up(), ;
                      oAvailable:forceStable(), ;
                      oAvailable:refreshAll(),;
                      DC_GetWhen(GetList)} ;
           TOOLTIP 'Move this item up' ;
           WHEN {||nPointerAvailable > 1}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Dn' SIZE 5,1 ;
           ACTION {|a|a := aAvailableList[nPointerAvailable], ;
                      ARemove(aAvailableList,nPointerAvailable), ;
                      ASize(aAvailableList,Len(aAvailableList)+1), ;
                      AIns(aAvailableList,nPointerAvailable+1,a), ;
                      oAvailable:down(), ;
                      oAvailable:forceStable(), ;
                      oAvailable:refreshAll(), ;
                      DC_GetWhen(GetList)} ;
           TOOLTIP 'Move this item Down' ;
           WHEN {||nPointerAvailable < Len(aAvailableList)}

@ nRow + nHeight, nCol2 DCPUSHBUTTON CAPTION 'Up' SIZE 5,1 ;
           ACTION {|a|a := aSelectedList[nPointerSelected], ;
                      ARemove(aSelectedList,nPointerSelected), ;
                      ASize(aSelectedList,Len(aSelectedList)+1), ;
                      AIns(aSelectedList,nPointerSelected-1,a), ;
                      oSelected:up(), ;
                      oSelected:forceStable(), ;
                      oSelected:refreshAll(), ;
                      DC_GetWhen(GetList)} ;
           TOOLTIP 'Move this item up' ;
           WHEN {||nPointerSelected > 1}


@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Dn' SIZE 5,1 ;
           ACTION {|a|a := aSelectedList[nPointerSelected], ;
                      ARemove(aSelectedList,nPointerSelected), ;
                      ASize(aSelectedList,Len(aSelectedList)+1), ;
                      AIns(aSelectedList,nPointerSelected+1,a), ;
                      oSelected:down(), ;
                      oSelected:forceStable(), ;
                      oSelected:refreshAll(), ;
                      DC_GetWhen(GetList)} ;
           TOOLTIP 'Move this item Down' ;
           WHEN {||nPointerSelected < Len(aSelectedList)}

nRow += 2.0
@ nRow + nHeight, nCol1 DCPUSHBUTTON CAPTION '<<' SIZE 5,1 ;
    ACTION {||PickSelected(aAvailableList,aSelectedList,oAvailable,oSelected,nPointerAvailable,-1)}

@ DCGUI_ROW, DCGUI_COL DCPUSHBUTTON CAPTION '<' SIZE 5,1 ;
    ACTION {||PickSelected(aAvailableList,aSelectedList,oAvailable,oSelected,nPointerAvailable,nPointerSelected)}

@ DCGUI_ROW, DCGUI_COL DCPUSHBUTTON CAPTION '>' SIZE 5,1 ;
    ACTION {||ListSelected(aAvailableList,aSelectedList,oAvailable,oSelected,nPointerAvailable,nPointerSelected)}

@ DCGUI_ROW, DCGUI_COL DCPUSHBUTTON CAPTION '>>' SIZE 5,1 ;
    ACTION {||ListSelected(aAvailableList,aSelectedList,oAvailable,oSelected,-1,nPointerSelected)}

@ DCGUI_ROW, DCGUI_COL DCPUSHBUTTON CAPTION 'Sort' SIZE 5,1 ;
    ACTION {||ASort(aAvailableList,,,{|a,b|a[1]<b[1]}),ASort(aSelectedList,,,{|a,b|a[1]<b[1]}), ;
              oAvailable:refreshAll(),oSelected:refreshAll()}

IF aButtons <> NIL
   nRow += 1.5+nHeight
   nWidth := 0
   nButtonWidth := 0
   FOR i := 1 to Len(aButtons)
      nWidth += Len(aButtons[i,1])
     IF Len(aButtons[i,1]) > nButtonWidth
        nButtonWidth := Len(aButtons[i,1])
     ENDIF
   NEXT
   nWidth += 4
   nButtonWidth += 4
   @ nRow, 0 DCTOOLBAR oToolBar SIZE nWidth,1.5 BUTTONSIZE nButtonWidth,1.5

   FOR i := 1 TO Len(aButtons)
      DCADDBUTTON ;
         CAPTION aButtons[i,1] ;
         ACTION _AnchorButton(aButtons[i,2],@oAvailable,@oSelected,@xCargo,@cFocus) ;
       TOOLTIP (aButtons[i,1]) ;
         SIZE Len(aButtons[i,1])+2, 1.5 ;
       PARENT oToolBar
   NEXT
ENDIF

RETURN NIL

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
STATIC FUNCTION _AnchorButton(bButton,oAvailable,oSelected,xCargo,cFocus)

RETURN {||Eval(bButton,@oAvailable,@oSelected,@xCargo,@cFocus)}

* -------------

STATIC FUNCTION Drop( oDrop, oColumn, mp1, oBrowse1, oBrowse2 )

LOCAL nOffset, aData1, aData2, nElement1, nElement2, lSame := .f., aValue

IF oDrop:parent == oColumn:parent // dragging within same browse
  oBrowse2 := oBrowse1
  lSame := .t.
ENDIF

aData1 := oBrowse1:dataSource
aData2 := oBrowse2:dataSource

nOffset := oDrop:dataArea:CellFromPos(mp1) - oBrowse1:RowPos
nElement1 := oBrowse1:arrayElement+nOffset
nElement2 := oBrowse2:arrayElement

IF nElement1 > Len(aData1)
  AAdd(aData1,aData2[nElement2])
  IF lSame
    ARemove( aData2, nElement2 )
  ENDIF
ELSEIF lSame
  aValue := aData1[nElement2]
  ARemove( aData2, nElement2 )
  ASize( aData1,Len(aData1)+1 )
  AIns(aData1,nElement1,aValue)
ELSE
  ASize(aData1,Len(aData1)+1)
  AIns(aData1,nElement1,aData2[nElement2])
ENDIF

oBrowse1:refreshAll()
IF !lSame
  ARemove( aData2, nElement2 )
  oBrowse2:refreshAll()
ENDIF

DC_PointerArrow(oBrowse1)
DC_PointerArrow(oBrowse2)

RETURN nil

* -----------

STATIC FUNCTION DragDialog( mp1, mp2, oXbp )

LOCAL GetList[0], GetOptions, oDialog, aPos, cText

IF oXbp:isDerivedFrom('XbpColumn')
  cText := Trim(Eval(oXbp:dataLink))
ELSEIF oXbp:isDerivedFrom('XbpStatic')
  cText := Trim(oXbp:caption)
ELSEIF oXbp:isDerivedFrom('XbpTreeView')
  cText := Trim(oXbp:getData():caption)
ENDIF
IF len(trim(cText)) > 100
   cText := subs(cText,1,100)
ENDIF

@ 2,0 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 10,1.2 ;
   CAPTION " "  //".\bitmaps\info1.Bmp"

@ DCGUI_ROW, DCGUI_COL DCSAY cText ;
   COLOR GRA_CLR_BLACK, GRA_CLR_YELLOW ;
   FONT '10.Courier' SAYSIZE 0,1.2 ;
   OPTION XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_VCENTER

DCGETOPTIONS NOTITLEBAR ORIGIN XBPDLG_ORIGIN_MOUSE ;
   FITPAD 0 COLOR { 240, 240, 255 } ;
   BORDER XBPDLG_NO_BORDER ;
   HIDE ;
   NOTASKLIST

DCREAD GUI FIT OPTIONS GetOptions PARENT @oDialog EXIT NOAUTORESTORE

aPos := DC_CalcAbsolutePosition(mp1,oXbp)
aPos[2] -= (oDialog:currentSize()[2] + 30)
oDialog:setPos( aPos )
oDialog:show()


RETURN oDialog

* -------------

STATIC FUNCTION lbUp( aArray, nPointer, oBrowse )

IF AppKeyState(xbeK_CTRL) == 1
  aArray[nPointer,2] := !aArray[nPointer,2]
  oBrowse:refreshCurrent()
ENDIF

RETURN nil

* -------------

STATIC FUNCTION ListSelected( aAvailableList, aSelectedList, oAvailable, oSelected, nPointerAvailable, nPointerSelected )

LOCAL i, bError, nTagElement

IF nPointerSelected == 0
  nPointerSelected := 1
ENDIF

IF nPointerAvailable == 0 .OR. Empty(aAvailableList)
  RETURN nil
ENDIF

nTagelement := Len(aAvailableList[1])
IF nPointerAvailable > 0
  aAvailableList[nPointerAvailable,nTagElement] := .T.
ENDIF
FOR i := 1 TO Len(aAvailableList)
  IF nPointerAvailable == -1
    aAvailableList[i,nTagElement] := .T.
  ENDIF
  IF aAvailableList[i,nTagElement]
    aAvailableList[i,nTagElement] := .F.
    IF Empty(aSelectedList)
      AAdd( aSelectedList, aAvailableList[i])
    ELSE
      ASize(aSelectedList,Len(aSelectedList)+1)
      AIns(aSelectedList,nPointerSelected,aAvailableList[i])
    ENDIF
    ARemove(aAvailableList,i)
    i--
  ENDIF
NEXT
oAvailable:refreshAll()
oSelected:refreshAll()

RETURN nil

* -------------

STATIC FUNCTION PickSelected( aAvailableList, aSelectedList, oAvailable, oSelected, nPointerAvailable, nPointerSelected )

LOCAL i, nTagElement

IF nPointerAvailable == 0
  nPointerAvailable := 1
ENDIF

IF nPointerSelected == 0 .OR. Empty(aSelectedList)
  RETURN nil
ENDIF

nTagElement := Len(aSelectedList[1])

IF nPointerSelected > 0
  aSelectedList[nPointerSelected,nTagElement] := .T.
ENDIF
FOR i := 1 TO Len(aSelectedList)
  IF nPointerSelected == -1
    aSelectedList[i,nTagElement] := .T.
  ENDIF
  IF aSelectedList[i,nTagElement]
    aSelectedList[i,nTagElement] := .F.
    IF Empty(aAvailableList)
      AAdd( aAvailableList, aSelectedList[i])
    ELSE
      ASize(aAvailableList,Len(aAvailableList)+1)
      AIns(aAvailableList,nPointerAvailable,aSelectedList[i])
    ENDIF
    ARemove(aSelectedList,i)
    i--
  ENDIF
NEXT

oAvailable:refreshAll()
oSelected:refreshAll()

RETURN nil





